function en=Teager(sig)
%
% Teager Energy Operator. T{x[n]} = x[n]^2 - x[n-1]x[n+1]
%
%  ----INPUT PARAMETERS----
%    sig: input signal
%
%  ----OUTPUT PARAMENTERS----
%    en: energy of Teager operator
%
% (c) Yannis Pantazis, 2007, csd, uoc
%     mail: pantazis@csd.uoc.gr

Lsig  = length(sig);

en = sig(2:Lsig-1).^2 - sig(1:Lsig-2).*sig(3:Lsig);

